{%- from "gnocchi/map.jinja" import server,cfg with context %}
{%- if server.get('enabled', False) %}

include:
  - apache
  - gnocchi._common
  - gnocchi.backend.upgrade

gnocchi_server_packages:
  pkg.installed:
  - names: {{ server.pkgs }}
  - require:
    - sls: gnocchi._common
  - require_in:
    - sls: gnocchi.backend.upgrade

apache_enable_gnocchi_wsgi:
  apache_site.enabled:
  - name: wsgi_gnocchi
  {%- if grains.get('noservices') %}
  - onlyif: /bin/false
  {%- endif %}
  - require:
    - sls: apache.server.site
    - sls: gnocchi.backend.upgrade
  - watch_in:
    - service: apache_service

gnocchi_server_services:
  service.running:
  - enable: true
  - names: {{ server.services }}
  {%- if grains.get('noservices') %}
  - onlyif: /bin/false
  {%- endif %}
  - require:
    - sls: gnocchi.backend.upgrade
    - sls: gnocchi._common
  - watch:
    - gnocchi_common_conf

/etc/gnocchi/{{ server.get('oslo_policy', {}).get('policy_file', 'policy.json') }}:
  file.managed:
    - mode: 0640
    - user: root
    - group: gnocchi
    - require:
      - pkg: gnocchi_server_packages

{%- for name, rule in server.get('policy', {}).iteritems() %}

  {%- if rule != None %}
gnocchi_keystone_rule_{{ name }}_present:
  keystone_policy.rule_present:
  - path: /etc/gnocchi/{{ server.get('oslo_policy', {}).get('policy_file', 'policy.json') }}
  - name: '{{ name }}'
  - rule: '{{ rule }}'
  - require:
    - pkg: gnocchi_server_packages
    - file: /etc/gnocchi/{{ server.get('oslo_policy', {}).get('policy_file', 'policy.json') }}

  {%- else %}

gnocchi_keystone_rule_{{ name }}_absent:
  keystone_policy.rule_absent:
  - path: /etc/gnocchi/{{ server.get('oslo_policy', {}).get('policy_file', 'policy.json') }}
  - name: '{{ name }}'
  - require:
    - pkg: gnocchi_server_packages
    - file: /etc/gnocchi/{{ server.get('oslo_policy', {}).get('policy_file', 'policy.json') }}

  {%- endif %}

{%- endfor %}

{%- endif %}
